-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function init()
	electrics.values['shiftknob_H'] = 0
	electrics.values['shiftknob_V'] = 0
end

local function reset()
	init()
end

local function setShiftPosition(h,v)
	--equalize movement
	if v < 0 then v = v * 0.6 end
	
	electrics.values['shiftknob_H'] = h
	electrics.values['shiftknob_V'] = v
end

local function updateGFX(dt)
	local gr = drivetrain.gear
	
	--neuteral
	if gr == 0 then setShiftPosition(0,0) return end
	--reverse
	if gr == -1 then setShiftPosition(1,-1) return end
	--other gears:
	local vpos = 0
	local hpos = 0
	if gr % 2 == 0 then 
		--gear shift is at bottom
		vpos = -1
	else
		--gear shift is at top
		vpos = 1
	end
	
	--gear shift is at left
	if gr == 1 or gr == 2 then hpos = -1 end
	--gear shift is at right
	if gr == 5 then hpos = 1 end

	setShiftPosition(hpos,vpos)
end

-- public interface
M.init      = init
M.reset     = reset
M.updateGFX = updateGFX

return M