-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local roofMoving = false
local roofMoveDirection = 0
local sensitivity = 0.04

local function init()
	electrics.values['lifter'] = 0
	electrics.values['roof'] = 0
	roofMoving = false
	roofMovingDirection = 0	
end

local function reset()
	init()
end

local function clamp01(val)
if val > 1 then return 1 end
if val < 0 then return 0 end
return val
end

local function setRoofMoving(direction)
	roofMoving = true
	roofMoveDirection = direction
end

local function updateGFX(dt)
	electrics.values['lifter'] = math.min(1, math.max(-0.0, (electrics.values['lifter'] + electrics.values['turnsignal'] * dt * 0.6)))
	if input.keys["G"] then
		setRoofMoving(1)
	end
	if input.keys["T"] then
		setRoofMoving(-1)
	end
	if roofMoving then
		--get the hydro value
		local hydroVal = electrics.values['roof']
		
		--calculate the increment amount
		local incAmount = (sensitivity * (bullettime.simulationSpeed / 180))
		hydroVal = hydroVal + (incAmount * roofMoveDirection)
		
		--make sure the roof hydro isnt above 1 or below 0
		hydroVal = clamp01(hydroVal)
		
		--set the hydro value
		electrics.values['roof'] = hydroVal
		
		--the roof has finished extending or retracting
		if hydroVal == 0 or hydroVal == 1 then roofMoving = false end
	end	
	
	
end

-- public interface
--M.init      = init
--M.reset     = reset
--M.updateGFX = updateGFX

return M